Bug 1747453 - glibc: Add --preload option to the dynamic loader
Summary: glibc: Add --preload option to the dynamic loader
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: glibc
Version: 8.2
Hardware: All
OS: Linux
low
low
Target Milestone: pre-dev-freeze
: 8.2
Assignee: Patsy Griffin
QA Contact: qe-baseos-tools-bugs
Oss Tikhomirova
URL:
Whiteboard:
Depends On: 1749633
Blocks: 1746918
TreeView+ depends on / blocked
 
Reported: 2019-08-30 13:20 UTC by Florian Weimer
Modified: 2020-04-28 16:50 UTC (History)
8 users (show)

Fixed In Version: glibc-2.28-75.el8
Doc Type: Enhancement
Doc Text:
.The `glibc` dynamic loader is enhanced to provide a non-inheriting library preloading mechanism With this enhancement, the loader can now be invoked to load a user program with a `--preload` option followed by a colon-separated list of libraries to preload. This feature allows users to invoke their programs directly through the loader with a non-inheriting library preload list. Previously, users had to use the LD_PRELOAD environment variable which was inherited by all child processes through their environment.
Clone Of:
Environment:
Last Closed: 2020-04-28 16:50:14 UTC
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:1828 None None None 2020-04-28 16:50:50 UTC

Description Florian Weimer 2019-08-30 13:20:33 UTC
We should backport this commit to provide a non-inheriting version of LD_PRELOAD:

commit 8692ebdb1259be60c545fa509d4852b26703777e
Author: David Newall <glibc@davidnewall.com>
Date:   Mon Feb 4 13:35:11 2019 +0100

    elf: Implement --preload option for the dynamic linker

The upstream commit comes with a test case.

Comment 1 Carlos O'Donell 2019-10-07 04:54:06 UTC
release/2.30/master - Not required.
release/2.29/master - Not required.
release/2.28/master - Not required.

Not putting --preload change on 2.28 or 2.28 because it's an interface change. It's downstream only. We want it in RHEL to help with testing and that could use --preload instead of an env var LD_PRELOAD.

Comment 2 Carlos O'Donell 2019-10-22 13:39:52 UTC
Please backport patch to Fedora (if required):
Fedora 31
Fedora 30
Fedora 29

Comment 3 Carlos O'Donell 2019-10-30 02:32:15 UTC
Skip the F29 backport.

Comment 5 Sergey Kolosov 2019-12-16 09:10:44 UTC
Verified with elf/tst-rtld-preload glibc test case.

Comment 13 errata-xmlrpc 2020-04-28 16:50:14 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2020:1828


Note You need to log in before you can comment on or make changes to this bug.